CVE-2022-31129

Uncontrolled Resource Consumption in nuget/Moment.js

Identifiers

GHSA-wc69-rhjr-hc9g, CVE-2022-31129

Package Slug

nuget/Moment.js

Vulnerability

Uncontrolled Resource Consumption

Description

moment is a JavaScript date library for parsing, validating, manipulating, and formatting dates. Affected versions of moment were found to use an inefficient parsing algorithm. Specifically using string-to-date parsing in moment (more specifically rfc2822 parsing, which is tried by default) has quadratic (N^2) complexity on specific inputs. Users may notice a noticeable slowdown is observed with inputs above 10k characters. Users who pass user-provided strings without sanity length checks to moment constructor is vulnerable to (Re)DoS attacks. The problem is patched in 2.29.4, the patch can be applied to all affected versions with minimal tweaking. Users are advised to upgrade. Users unable to upgrade should consider limiting date lengths accepted from user input.

Affected Versions

All versions starting from 2.18.0 before 2.29.4

Solution

Upgrade to version 2.29.4 or above.

Last Modified

2022-07-26

source